unit FrmStore;

{

   COPYRIGHT 1999 .. 2014 Blue Hell / Jan Punter

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2 as
  published by the Free Software Foundation;

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  For all listed email addresses :

    _dot. to be substituted by a dot      '.'
    2@t2  to be substituted by an at sign '@'


  Blue Hell is a trade mark owned by

    Jan Punter
    Oogstplein 6
    7545 HP Enschede
    the Netherlands
    http://www.iaf.nl/Users/BlueHell/
    http://bluehell.electro-music.com/
    j_dot.punter2@t2iaf_dot.nl

  All rights attributed to Blue Hell are owned by Jan Punter.
}

interface

uses

  WinApi.Windows, WinApi.Messages, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.Buttons, Vcl.Imaging.jpeg, Vcl.ImgList, Vcl.Samples.Spin,
  Vcl.Imaging.pngimage,

  knobs2013;

type

  TOnDesignerLog = procedure( aSender: TObject; const aMsg: string) of object;

  TFormStore = class(TForm)
    ImageAdder: TImage;
    ImageAmplifier: TImage;
    ImageGate: TImage;
    ImageAudioIn: TImage;
    ImageAudioOut: TImage;
    ImageAverage: TImage;
    ImageConstant: TImage;
    ImageDFlipFlop: TImage;
    ImageDelay: TImage;
    ImageDisplay: TImage;
    ImageDivider: TImage;
    ImageEnvADSR: TImage;
    ImageEnvAHD: TImage;
    ImageEnvAR: TImage;
    ImageEnvARRetrig: TImage;
    ImageHrastOsc: TImage;
    ImageIntDif: TImage;
    ImageInverter: TImage;
    ImageLfo: TImage;
    ImageLfoTrig: TImage;
    ImageMidiCCIn: TImage;
    ImageMidiCCOut: TImage;
    ImageMidiNoteIn: TImage;
    ImageMidiNoteOut: TImage;
    ImageMinMax: TImage;
    ImageMixM4to1: TImage;
    ImageMixM6to6: TImage;
    ImageMixS2to1: TImage;
    ImageMultiplier: TImage;
    ImageNoise: TImage;
    ImageNoiseLfo: TImage;
    ImageNoiseLfoTrig: TImage;
    ImageNoiseTrig: TImage;
    ImageNot: TImage;
    ImageNotes: TImage;
    ImagePan: TImage;
    ImagePanel1: TImage;
    ImagePanel2: TImage;
    ImagePanel3: TImage;
    ImagePanel4: TImage;
    ImagePanel5: TImage;
    ImageQuantizer: TImage;
    ImageRSFlipFlop: TImage;
    ImageRandomWalkLfo: TImage;
    ImageRatio: TImage;
    ImageRectifier: TImage;
    ImageRotator: TImage;
    ImageSVF: TImage;
    ImageSampleAndHold: TImage;
    ImageScaler: TImage;
    ImageSeqClockStep: TImage;
    ImageSeqStep: TImage;
    ImageSequencer: TImage;
    ImageOsc: TImage;
    ImageOscTrig: TImage;
    ImageSquare: TImage;
    ImageSquareLfo: TImage;
    ImageSquareLfoTrig: TImage;
    ImageSquareTrig: TImage;
    ImageSwitch2to1: TImage;
    ImageTextSequencer: TImage;
    ImageTrackAndHold: TImage;
    ImageWavePlayer: TImage;
    ImageXFade: TImage;
    MemoAdder: TMemo;
    MemoAmplifier: TMemo;
    MemoGate: TMemo;
    MemoAudioIn: TMemo;
    MemoAudioOut: TMemo;
    MemoAverage: TMemo;
    MemoConstant: TMemo;
    MemoDFlipFlop: TMemo;
    MemoDelay: TMemo;
    MemoDisplay: TMemo;
    MemoDivider: TMemo;
    MemoEnvADSR: TMemo;
    MemoEnvAHD: TMemo;
    MemoEnvAR: TMemo;
    MemoEnvARRetrig: TMemo;
    MemoHrastOsc: TMemo;
    MemoIntDif: TMemo;
    MemoInverter: TMemo;
    MemoLfo: TMemo;
    MemoLfoTrig: TMemo;
    MemoMidiCCIn: TMemo;
    MemoMidiCCOut: TMemo;
    MemoMidiNoteIn: TMemo;
    MemoMidiNoteOut: TMemo;
    MemoMinMax: TMemo;
    MemoMixM4to1: TMemo;
    MemoMixM6to6: TMemo;
    MemoMixS2to1: TMemo;
    MemoMultiplier: TMemo;
    MemoNoise: TMemo;
    MemoNoiseLfo: TMemo;
    MemoNoiseLfoTrig: TMemo;
    MemoNoiseTrig: TMemo;
    MemoNot: TMemo;
    MemoNotes: TMemo;
    MemoPan: TMemo;
    MemoPanel1: TMemo;
    MemoPanel2: TMemo;
    MemoPanel3: TMemo;
    MemoPanel4: TMemo;
    MemoPanel5: TMemo;
    MemoQuantizer: TMemo;
    MemoRSFlipFlop: TMemo;
    MemoRandomWalkLfo: TMemo;
    MemoRatio: TMemo;
    MemoRectifier: TMemo;
    MemoRotator: TMemo;
    MemoSVF: TMemo;
    MemoSampleAndHold: TMemo;
    MemoScaler: TMemo;
    MemoSeqClockStep: TMemo;
    MemoSeqStep: TMemo;
    MemoSequencer: TMemo;
    MemoOsc: TMemo;
    MemoOscTrig: TMemo;
    MemoSquare: TMemo;
    MemoSquareLfo: TMemo;
    MemoSquareLfoTrig: TMemo;
    MemoSquareTrig: TMemo;
    MemoSwitch2to1: TMemo;
    MemoTextSequencer: TMemo;
    MemoTrackAndHold: TMemo;
    MemoWavePlayer: TMemo;
    MemoXFade: TMemo;
    adder: TKnobsModule;
    adder_editlabel: TKnobsEditLabel;
    adder_image: TImage;
    adder_in1: TKnobsInput;
    adder_in2: TKnobsInput;
    adder_in3: TKnobsInput;
    adder_in4: TKnobsInput;
    adder_mute: TKnobsSelector;
    adder_out: TKnobsOutput;
    amplifier: TKnobsModule;
    amplifier_display_gain: TKnobsDisplay;
    amplifier_editlabel: TKnobsEditLabel;
    amplifier_gain: TKnobsSmallKnob;
    amplifier_image: TImage;
    amplifier_in1: TKnobsInput;
    amplifier_in2: TKnobsInput;
    amplifier_in3: TKnobsInput;
    amplifier_in4: TKnobsInput;
    amplifier_mute: TKnobsSelector;
    amplifier_out1: TKnobsOutput;
    amplifier_out2: TKnobsOutput;
    amplifier_out3: TKnobsOutput;
    amplifier_out4: TKnobsOutput;
    audioin: TKnobsModule;
    audioin_editlabel: TKnobsEditLabel;
    audioin_out1: TKnobsOutput;
    audioin_out2: TKnobsOutput;
    audioin_textlabel_l_out: TKnobsTextLabel;
    audioin_textlabel_r_out: TKnobsTextLabel;
    audioout: TKnobsModule;
    audioout_editlabel: TKnobsEditLabel;
    audioout_in1: TKnobsInput;
    audioout_in2: TKnobsInput;
    audioout_textlabel_l_in: TKnobsTextLabel;
    audioout_textlabel_r_in: TKnobsTextLabel;
    avg: TKnobsModule;
    avg_alpha: TKnobsSmallKnob;
    avg_editlabel: TKnobsEditLabel;
    avg_hp: TKnobsOutput;
    avg_image: TImage;
    avg_in: TKnobsInput;
    avg_lp: TKnobsOutput;
    avg_textlabel_in: TKnobsTextLabel;
    avg_textlabel_invout: TKnobsTextLabel;
    avg_textlabel_out: TKnobsTextLabel;
    constant: TKnobsModule;
    constant_display_value: TKnobsDisplay;
    constant_editlabel: TKnobsEditLabel;
    constant_mute: TKnobsSelector;
    constant_out: TKnobsOutput;
    constant_value: TKnobsSmallKnob;
    delay: TKnobsModule;
    delay_delay: TKnobsInput;
    delay_display_length: TKnobsDisplay;
    delay_editlabel: TKnobsEditLabel;
    delay_in: TKnobsInput;
    delay_length: TKnobsSmallKnob;
    delay_out: TKnobsOutput;
    delay_outfixed: TKnobsOutput;
    delay_range: TKnobsSelector;
    delay_tabseet: TTabSheet;
    delay_textlabel_delay: TKnobsTextLabel;
    delay_textlabel_fixed: TKnobsTextLabel;
    delay_textlabel_in: TKnobsTextLabel;
    delay_textlabel_maxdelay: TKnobsTextLabel;
    dflipflop: TKnobsModule;
    dflipflop_clk: TKnobsInput;
    dflipflop_d: TKnobsInput;
    dflipflop_editlabel: TKnobsEditLabel;
    dflipflop_image: TImage;
    dflipflop_indicator_notq: TKnobsIndicator;
    dflipflop_indicator_q: TKnobsIndicator;
    dflipflop_notq: TKnobsOutput;
    dflipflop_q: TKnobsOutput;
    display: TKnobsModule;
    display_editlabel: TKnobsEditLabel;
    display_in1: TKnobsInput;
    display_in2: TKnobsInput;
    display_knobsbox_left: TKnobsBox;
    display_knobsbox_right: TKnobsBox;
    display_level1: TKnobsIndicatorBar;
    display_level2: TKnobsIndicatorBar;
    display_mode: TKnobsSelector;
    display_textlabel_db: TKnobsTextLabel;
    divider: TKnobsModule;
    divider_count: TKnobsSmallKnob;
    divider_display_count: TKnobsDisplay;
    divider_editlabel: TKnobsEditLabel;
    divider_indicator_out: TKnobsIndicator;
    divider_out: TKnobsOutput;
    divider_symbol_trig: TImage;
    divider_textlabel_trig: TKnobsTextLabel;
    divider_trig: TKnobsInput;
    envadsr: TKnobsModule;
    envadsr_ashape: TKnobsSelector;
    envadsr_attack: TKnobsSmallKnob;
    envadsr_decay: TKnobsSmallKnob;
    envadsr_display_attack: TKnobsDisplay;
    envadsr_display_decay: TKnobsDisplay;
    envadsr_display_release: TKnobsDisplay;
    envadsr_display_sustain: TKnobsDisplay;
    envadsr_dshape: TKnobsSelector;
    envadsr_editlabel: TKnobsEditLabel;
    envadsr_gain: TKnobsInput;
    envadsr_indicator_trig: TKnobsIndicator;
    envadsr_mode: TKnobsSelector;
    envadsr_mute: TKnobsSelector;
    envadsr_out: TKnobsOutput;
    envadsr_arange: TKnobsSelector;
    envadsr_release: TKnobsSmallKnob;
    envadsr_rshape: TKnobsSelector;
    envadsr_sigin: TKnobsInput;
    envadsr_sigout: TKnobsOutput;
    envadsr_sustain: TKnobsSmallKnob;
    envadsr_symbol_connect: TImage;
    envadsr_symbol_trig: TImage;
    envadsr_textlabel_attack: TKnobsTextLabel;
    envadsr_textlabel_decay: TKnobsTextLabel;
    envadsr_textlabel_env: TKnobsTextLabel;
    envadsr_textlabel_gain: TKnobsTextLabel;
    envadsr_textlabel_release: TKnobsTextLabel;
    envadsr_textlabel_sustain: TKnobsTextLabel;
    envadsr_trig: TKnobsInput;
    envadsr_viewer: TKnobsDataViewer;
    envahd: TKnobsModule;
    envahd_ashape: TKnobsSelector;
    envahd_attack: TKnobsSmallKnob;
    envahd_decay: TKnobsSmallKnob;
    envahd_display_attack: TKnobsDisplay;
    envahd_display_decay: TKnobsDisplay;
    envahd_display_hold: TKnobsDisplay;
    envahd_dshape: TKnobsSelector;
    envahd_editlabel: TKnobsEditLabel;
    envahd_gain: TKnobsInput;
    envahd_hold: TKnobsSmallKnob;
    envahd_indicator_trig: TKnobsIndicator;
    envahd_mode: TKnobsSelector;
    envahd_mute: TKnobsSelector;
    envahd_out: TKnobsOutput;
    envahd_arange: TKnobsSelector;
    envahd_sigin: TKnobsInput;
    envahd_sigout: TKnobsOutput;
    envahd_symbol_connect: TImage;
    envahd_symbol_trig: TImage;
    envahd_textlabel_attack: TKnobsTextLabel;
    envahd_textlabel_decay: TKnobsTextLabel;
    envahd_textlabel_env: TKnobsTextLabel;
    envahd_textlabel_gain: TKnobsTextLabel;
    envahd_textlabel_hold: TKnobsTextLabel;
    envahd_trig: TKnobsInput;
    envahd_viewer: TKnobsDataViewer;
    envar: TKnobsModule;
    envar_attack: TKnobsSmallKnob;
    envar_display_attack: TKnobsDisplay;
    envar_display_release: TKnobsDisplay;
    envar_editlabel: TKnobsEditLabel;
    envar_gain: TKnobsInput;
    envar_indicator_trig: TKnobsIndicator;
    envar_mute: TKnobsSelector;
    envar_out: TKnobsOutput;
    envar_release: TKnobsSmallKnob;
    envar_sigin: TKnobsInput;
    envar_sigout: TKnobsOutput;
    envar_symbol_connect: TImage;
    envar_textlabel_attack: TKnobsTextLabel;
    envar_textlabel_gain: TKnobsTextLabel;
    envar_textlabel_release: TKnobsTextLabel;
    envar_textlabel_trig: TKnobsTextLabel;
    envar_trig: TKnobsInput;
    envarretrig: TKnobsModule;
    envarretrig_attack: TKnobsSmallKnob;
    envarretrig_display_attack: TKnobsDisplay;
    envarretrig_display_release: TKnobsDisplay;
    envarretrig_editlabel: TKnobsEditLabel;
    envarretrig_gain: TKnobsInput;
    envarretrig_indicator_trig: TKnobsIndicator;
    envarretrig_mute: TKnobsSelector;
    envarretrig_out: TKnobsOutput;
    envarretrig_release: TKnobsSmallKnob;
    envarretrig_sigin: TKnobsInput;
    envarretrig_sigout: TKnobsOutput;
    envarretrig_symbol_connect: TImage;
    envarretrig_symbol_trig: TImage;
    envarretrig_textlabel_attack: TKnobsTextLabel;
    envarretrig_textlabel_gain: TKnobsTextLabel;
    envarretrig_textlabel_release: TKnobsTextLabel;
    envarretrig_textlabel_trig: TKnobsTextLabel;
    envarretrig_trig: TKnobsInput;
    envelope_tabsheet: TTabSheet;
    filter_tabsheet: TTabSheet;
    gate: TKnobsModule;
    gate_editlabel: TKnobsEditLabel;
    gate_function: TKnobsSelector;
    gate_in1: TKnobsInput;
    gate_in2: TKnobsInput;
    gate_in3: TKnobsInput;
    gate_in4: TKnobsInput;
    gate_indicator_out: TKnobsIndicator;
    gate_out: TKnobsOutput;
    hrastOscLabelSync: TKnobsTextLabel;
    hrastOsc_FMInput: TKnobsInput;
    hrastOsc_PMInput: TKnobsInput;
    hrastOsc_PWMInput: TKnobsInput;
    hrastosc: TKnobsModule;
    hrastosc_Bandlimit: TKnobsSmallKnob;
    hrastosc_FM: TKnobsSmallKnob;
    hrastosc_Freq: TKnobsSmallKnob;
    hrastosc_Level: TKnobsSmallKnob;
    hrastosc_Morph: TKnobsSmallKnob;
    hrastosc_Mute: TKnobsSelector;
    hrastosc_Output: TKnobsOutput;
    hrastosc_PM: TKnobsSmallKnob;
    hrastosc_PW: TKnobsSmallKnob;
    hrastosc_PWM: TKnobsSmallKnob;
    hrastosc_Shape: TKnobsSmallKnob;
    hrastosc_SyncInput: TKnobsInput;
    hrastosc_Vintage: TKnobsSelector;
    hrastosc_display_freq: TKnobsDisplay;
    hrastosc_symbol_sync: TImage;
    hrastosc_textlabel_FM: TKnobsTextLabel;
    hrastosc_textlabel_bandlimit: TKnobsTextLabel;
    hrastosc_textlabel_editlabel: TKnobsEditLabel;
    hrastosc_textlabel_level: TKnobsTextLabel;
    hrastosc_textlabel_morph: TKnobsTextLabel;
    hrastosc_textlabel_pm: TKnobsTextLabel;
    hrastosc_textlabel_pw: TKnobsTextLabel;
    hrastosc_textlabel_pwm: TKnobsTextLabel;
    hrastosc_textlabel_shape: TKnobsTextLabel;
    inout_tabsheet: TTabSheet;
    intdif: TKnobsModule;
    intdif_dif: TKnobsOutput;
    intdif_editlabel: TKnobsEditLabel;
    intdif_image: TImage;
    intdif_in: TKnobsInput;
    intdif_int: TKnobsOutput;
    intdif_textlabel_dif: TKnobsTextLabel;
    intdif_textlabel_int: TKnobsTextLabel;
    inverter: TKnobsModule;
    inverter_editlabel: TKnobsEditLabel;
    inverter_image: TImage;
    inverter_in1: TKnobsInput;
    inverter_in2: TKnobsInput;
    inverter_in3: TKnobsInput;
    inverter_in4: TKnobsInput;
    inverter_out1: TKnobsOutput;
    inverter_out2: TKnobsOutput;
    inverter_out3: TKnobsOutput;
    inverter_out4: TKnobsOutput;
    lfo: TKnobsModule;
    lfo_display_frequency: TKnobsDisplay;
    lfo_editlabel: TKnobsEditLabel;
    lfo_fm: TKnobsInput;
    lfo_fmlevel: TKnobsSmallKnob;
    lfo_frequency: TKnobsSmallKnob;
    lfo_indicator_out: TKnobsIndicator;
    lfo_indicator_res: TKnobsIndicator;
    lfo_mute: TKnobsSelector;
    lfo_out: TKnobsOutput;
    lfo_phase: TKnobsInput;
    lfo_pmlevel: TKnobsSmallKnob;
    lfo_range: TKnobsSelector;
    lfo_res: TKnobsInput;
    lfo_shape: TKnobsSelector;
    lfo_symbol_res: TImage;
    lfo_sync: TKnobsOutput;
    lfo_tabsheet: TTabSheet;
    lfo_textlabel_fm: TKnobsTextLabel;
    lfo_textlabel_out: TKnobsTextLabel;
    lfo_textlabel_phase: TKnobsTextLabel;
    lfo_textlabel_res: TKnobsTextLabel;
    lfo_textlabel_sync: TKnobsTextLabel;
    lfotrig: TKnobsModule;
    lfotrig_count: TKnobsNoKnob;
    lfotrig_display_count: TKnobsDisplay;
    lfotrig_display_frequency: TKnobsDisplay;
    lfotrig_editlabel: TKnobsEditLabel;
    lfotrig_fm: TKnobsInput;
    lfotrig_fmlevel: TKnobsSmallKnob;
    lfotrig_frequency: TKnobsSmallKnob;
    lfotrig_indicator_out: TKnobsIndicator;
    lfotrig_indicator_ready: TKnobsIndicator;
    lfotrig_indicator_trig: TKnobsIndicator;
    lfotrig_mute: TKnobsSelector;
    lfotrig_out: TKnobsOutput;
    lfotrig_range: TKnobsSelector;
    lfotrig_ready: TKnobsOutput;
    lfotrig_shape: TKnobsSelector;
    lfotrig_symbol_trig: TImage;
    lfotrig_textlabel_fm: TKnobsTextLabel;
    lfotrig_textlabel_out: TKnobsTextLabel;
    lfotrig_textlabel_ready: TKnobsTextLabel;
    lfotrig_textlabel_trig: TKnobsTextLabel;
    lfotrig_trig: TKnobsInput;
    logic_tabsheet: TTabSheet;
    logicnot: TKnobsModule;
    logicnot_editlabel: TKnobsEditLabel;
    logicnot_image: TImage;
    logicnot_in1: TKnobsInput;
    logicnot_in2: TKnobsInput;
    logicnot_in3: TKnobsInput;
    logicnot_in4: TKnobsInput;
    logicnot_indicator_out1: TKnobsIndicator;
    logicnot_indicator_out2: TKnobsIndicator;
    logicnot_indicator_out3: TKnobsIndicator;
    logicnot_indicator_out4: TKnobsIndicator;
    logicnot_out1: TKnobsOutput;
    logicnot_out2: TKnobsOutput;
    logicnot_out3: TKnobsOutput;
    logicnot_out4: TKnobsOutput;
    midi_tabsheet: TTabSheet;
    midiccin: TKnobsModule;
    midiccin_cc: TKnobsNoKnob;
    midiccin_ch: TKnobsNoKnob;
    midiccin_display_cc: TKnobsDisplay;
    midiccin_display_ch: TKnobsDisplay;
    midiccin_editlabel: TKnobsEditLabel;
    midiccin_gate: TKnobsOutput;
    midiccin_indicator_gate: TKnobsIndicator;
    midiccin_textlabel_cc: TKnobsTextLabel;
    midiccin_textlabel_gate: TKnobsTextLabel;
    midiccin_textlabel_value: TKnobsTextLabel;
    midiccin_value: TKnobsOutput;
    midiccout: TKnobsModule;
    midiccout_cc: TKnobsNoKnob;
    midiccout_ch: TKnobsNoKnob;
    midiccout_display_cc: TKnobsDisplay;
    midiccout_display_ch: TKnobsDisplay;
    midiccout_editlabel: TKnobsEditLabel;
    midiccout_gate: TKnobsInput;
    midiccout_indicator_gate: TKnobsIndicator;
    midiccout_textlabel_cc: TKnobsTextLabel;
    midiccout_textlabel_gate: TKnobsTextLabel;
    midiccout_textlabel_value: TKnobsTextLabel;
    midiccout_value: TKnobsInput;
    midinotein: TKnobsModule;
    midinotein_ch: TKnobsNoKnob;
    midinotein_display_ch: TKnobsDisplay;
    midinotein_editlabel: TKnobsEditLabel;
    midinotein_gate: TKnobsOutput;
    midinotein_indicator_gate: TKnobsIndicator;
    midinotein_note: TKnobsOutput;
    midinotein_textlabel_gate: TKnobsTextLabel;
    midinotein_textlabel_note: TKnobsTextLabel;
    midinotein_textlabel_velocity: TKnobsTextLabel;
    midinotein_textlabel_veloff: TKnobsTextLabel;
    midinotein_textlabel_velon: TKnobsTextLabel;
    midinotein_veloff: TKnobsOutput;
    midinotein_velon: TKnobsOutput;
    midinoteout: TKnobsModule;
    midinoteout_ch: TKnobsNoKnob;
    midinoteout_display_ch: TKnobsDisplay;
    midinoteout_editlabel: TKnobsEditLabel;
    midinoteout_gate: TKnobsInput;
    midinoteout_indicator_gate: TKnobsIndicator;
    midinoteout_note: TKnobsInput;
    midinoteout_textlabel_gate: TKnobsTextLabel;
    midinoteout_textlabel_note: TKnobsTextLabel;
    midinoteout_textlabel_velocity: TKnobsTextLabel;
    midinoteout_textlabel_veloff: TKnobsTextLabel;
    midinoteout_textlabel_velon: TKnobsTextLabel;
    midinoteout_veloff: TKnobsInput;
    midinoteout_velon: TKnobsInput;
    minmax: TKnobsModule;
    minmax_editlabel: TKnobsEditLabel;
    minmax_image: TImage;
    minmax_in1: TKnobsInput;
    minmax_in2: TKnobsInput;
    minmax_max: TKnobsOutput;
    minmax_min: TKnobsOutput;
    minmax_textlabel_1in2: TKnobsTextLabel;
    minmax_textlabel_minmax: TKnobsTextLabel;
    mixer_tabsheet: TTabSheet;
    mixm4to1: TKnobsModule;
    mixm4to1_editlabel: TKnobsEditLabel;
    mixm4to1_in1: TKnobsInput;
    mixm4to1_in2: TKnobsInput;
    mixm4to1_in3: TKnobsInput;
    mixm4to1_in4: TKnobsInput;
    mixm4to1_in: TKnobsInput;
    mixm4to1_level1: TKnobsSmallKnob;
    mixm4to1_level2: TKnobsSmallKnob;
    mixm4to1_level3: TKnobsSmallKnob;
    mixm4to1_level4: TKnobsSmallKnob;
    mixm4to1_mute2: TKnobsSelector;
    mixm4to1_mute3: TKnobsSelector;
    mixm4to1_mute4: TKnobsSelector;
    mixm4to1_mute1: TKnobsSelector;
    mixm4to1_out: TKnobsOutput;
    mixm6to6: TKnobsModule;
    mixm6to6_box_inchains: TKnobsBox;
    mixm6to6_box_ins: TKnobsBox;
    mixm6to6_box_outchains: TKnobsBox;
    mixm6to6_box_outs: TKnobsBox;
    mixm6to6_editlabel: TKnobsEditLabel;
    mixm6to6_in1: TKnobsInput;
    mixm6to6_in2: TKnobsInput;
    mixm6to6_in3: TKnobsInput;
    mixm6to6_in4: TKnobsInput;
    mixm6to6_in5: TKnobsInput;
    mixm6to6_in6: TKnobsInput;
    mixm6to6_inchcol1: TKnobsInput;
    mixm6to6_inchcol2: TKnobsInput;
    mixm6to6_inchcol3: TKnobsInput;
    mixm6to6_inchcol4: TKnobsInput;
    mixm6to6_inchcol5: TKnobsInput;
    mixm6to6_inchcol6: TKnobsInput;
    mixm6to6_inr1c1: TKnobsInput;
    mixm6to6_inr1c2: TKnobsInput;
    mixm6to6_inr1c3: TKnobsInput;
    mixm6to6_inr1c4: TKnobsInput;
    mixm6to6_inr1c5: TKnobsInput;
    mixm6to6_inr1c6: TKnobsInput;
    mixm6to6_inr2c1: TKnobsInput;
    mixm6to6_inr2c2: TKnobsInput;
    mixm6to6_inr2c3: TKnobsInput;
    mixm6to6_inr2c4: TKnobsInput;
    mixm6to6_inr2c5: TKnobsInput;
    mixm6to6_inr2c6: TKnobsInput;
    mixm6to6_inr3c1: TKnobsInput;
    mixm6to6_inr3c2: TKnobsInput;
    mixm6to6_inr3c3: TKnobsInput;
    mixm6to6_inr3c4: TKnobsInput;
    mixm6to6_inr3c5: TKnobsInput;
    mixm6to6_inr3c6: TKnobsInput;
    mixm6to6_inr4c1: TKnobsInput;
    mixm6to6_inr4c2: TKnobsInput;
    mixm6to6_inr4c3: TKnobsInput;
    mixm6to6_inr4c4: TKnobsInput;
    mixm6to6_inr4c5: TKnobsInput;
    mixm6to6_inr4c6: TKnobsInput;
    mixm6to6_inr5c1: TKnobsInput;
    mixm6to6_inr5c2: TKnobsInput;
    mixm6to6_inr5c3: TKnobsInput;
    mixm6to6_inr5c4: TKnobsInput;
    mixm6to6_inr5c5: TKnobsInput;
    mixm6to6_inr5c6: TKnobsInput;
    mixm6to6_inr6c1: TKnobsInput;
    mixm6to6_inr6c2: TKnobsInput;
    mixm6to6_inr6c3: TKnobsInput;
    mixm6to6_inr6c4: TKnobsInput;
    mixm6to6_inr6c5: TKnobsInput;
    mixm6to6_inr6c6: TKnobsInput;
    mixm6to6_levelr1c1: TKnobsSmallKnob;
    mixm6to6_levelr1c2: TKnobsSmallKnob;
    mixm6to6_levelr1c3: TKnobsSmallKnob;
    mixm6to6_levelr1c4: TKnobsSmallKnob;
    mixm6to6_levelr1c5: TKnobsSmallKnob;
    mixm6to6_levelr1c6: TKnobsSmallKnob;
    mixm6to6_levelr2c1: TKnobsSmallKnob;
    mixm6to6_levelr2c2: TKnobsSmallKnob;
    mixm6to6_levelr2c3: TKnobsSmallKnob;
    mixm6to6_levelr2c4: TKnobsSmallKnob;
    mixm6to6_levelr2c5: TKnobsSmallKnob;
    mixm6to6_levelr2c6: TKnobsSmallKnob;
    mixm6to6_levelr3c1: TKnobsSmallKnob;
    mixm6to6_levelr3c2: TKnobsSmallKnob;
    mixm6to6_levelr3c3: TKnobsSmallKnob;
    mixm6to6_levelr3c4: TKnobsSmallKnob;
    mixm6to6_levelr3c5: TKnobsSmallKnob;
    mixm6to6_levelr3c6: TKnobsSmallKnob;
    mixm6to6_levelr4c1: TKnobsSmallKnob;
    mixm6to6_levelr4c2: TKnobsSmallKnob;
    mixm6to6_levelr4c3: TKnobsSmallKnob;
    mixm6to6_levelr4c4: TKnobsSmallKnob;
    mixm6to6_levelr4c5: TKnobsSmallKnob;
    mixm6to6_levelr4c6: TKnobsSmallKnob;
    mixm6to6_levelr5c1: TKnobsSmallKnob;
    mixm6to6_levelr5c2: TKnobsSmallKnob;
    mixm6to6_levelr5c3: TKnobsSmallKnob;
    mixm6to6_levelr5c4: TKnobsSmallKnob;
    mixm6to6_levelr5c5: TKnobsSmallKnob;
    mixm6to6_levelr5c6: TKnobsSmallKnob;
    mixm6to6_levelr6c1: TKnobsSmallKnob;
    mixm6to6_levelr6c2: TKnobsSmallKnob;
    mixm6to6_levelr6c3: TKnobsSmallKnob;
    mixm6to6_levelr6c4: TKnobsSmallKnob;
    mixm6to6_levelr6c5: TKnobsSmallKnob;
    mixm6to6_levelr6c6: TKnobsSmallKnob;
    mixm6to6_mute1: TKnobsSelector;
    mixm6to6_mute2: TKnobsSelector;
    mixm6to6_mute3: TKnobsSelector;
    mixm6to6_mute4: TKnobsSelector;
    mixm6to6_mute5: TKnobsSelector;
    mixm6to6_mute6: TKnobsSelector;
    mixm6to6_out1: TKnobsOutput;
    mixm6to6_out2: TKnobsOutput;
    mixm6to6_out3: TKnobsOutput;
    mixm6to6_out4: TKnobsOutput;
    mixm6to6_out5: TKnobsOutput;
    mixm6to6_out6: TKnobsOutput;
    mixm6to6_outchrow1: TKnobsOutput;
    mixm6to6_outchrow2: TKnobsOutput;
    mixm6to6_outchrow3: TKnobsOutput;
    mixm6to6_outchrow4: TKnobsOutput;
    mixm6to6_outchrow5: TKnobsOutput;
    mixm6to6_outchrow6: TKnobsOutput;
    mixm6to6_textlabel_chains: TKnobsTextLabel;
    mixm6to6_textlabel_in: TKnobsTextLabel;
    mixm6to6_textlabel_out: TKnobsTextLabel;
    mixs2to1: TKnobsModule;
    mixs2to1_editlabel: TKnobsEditLabel;
    mixs2to1_inl1: TKnobsInput;
    mixs2to1_inl2: TKnobsInput;
    mixs2to1_inl: TKnobsInput;
    mixs2to1_inr1: TKnobsInput;
    mixs2to1_inr2: TKnobsInput;
    mixs2to1_inr: TKnobsInput;
    mixs2to1_level1: TKnobsSmallKnob;
    mixs2to1_level2: TKnobsSmallKnob;
    mixs2to1_mute2: TKnobsSelector;
    mixs2to1_mute1: TKnobsSelector;
    mixs2to1_outl: TKnobsOutput;
    mixs2to1_outr: TKnobsOutput;
    multiplier: TKnobsModule;
    multiplier_editlabel: TKnobsEditLabel;
    multiplier_image: TImage;
    multiplier_in1: TKnobsInput;
    multiplier_in2: TKnobsInput;
    multiplier_in3: TKnobsInput;
    multiplier_in4: TKnobsInput;
    multiplier_mute: TKnobsSelector;
    multiplier_out: TKnobsOutput;
    noise: TKnobsModule;
    noise_color: TKnobsSmallKnob;
    noise_display_color: TKnobsDisplay;
    noise_editlabel: TKnobsEditLabel;
    noise_mute: TKnobsSelector;
    noise_out: TKnobsOutput;
    noise_textlabel_color: TKnobsTextLabel;
    noiselfo: TKnobsModule;
    noiselfo_color: TKnobsSmallKnob;
    noiselfo_display_color: TKnobsDisplay;
    noiselfo_editlabel: TKnobsEditLabel;
    noiselfo_image: TImage;
    noiselfo_indicator_out: TKnobsIndicator;
    noiselfo_mute: TKnobsSelector;
    noiselfo_out: TKnobsOutput;
    noiselfo_textlabel_color: TKnobsTextLabel;
    noiselfotrig: TKnobsModule;
    noiselfotrig_color: TKnobsSmallKnob;
    noiselfotrig_display_color: TKnobsDisplay;
    noiselfotrig_editlabel: TKnobsEditLabel;
    noiselfotrig_image: TImage;
    noiselfotrig_indicator_out: TKnobsIndicator;
    noiselfotrig_indicator_trig: TKnobsIndicator;
    noiselfotrig_mute: TKnobsSelector;
    noiselfotrig_out: TKnobsOutput;
    noiselfotrig_symbol_trig: TImage;
    noiselfotrig_textlabel_trig: TKnobsTextLabel;
    noiselfotrig_trig: TKnobsInput;
    noiselfotrix_textlabel_color: TKnobsTextLabel;
    noisetrig: TKnobsModule;
    noisetrig_color: TKnobsSmallKnob;
    noisetrig_display_color: TKnobsDisplay;
    noisetrig_editlabel: TKnobsEditLabel;
    noisetrig_indicator_trig: TKnobsIndicator;
    noisetrig_mute: TKnobsSelector;
    noisetrig_out: TKnobsOutput;
    noisetrig_symbol_trig: TImage;
    noisetrig_textlabel_color: TKnobsTextLabel;
    noisetrig_textlabel_trig: TKnobsTextLabel;
    noisetrig_trig: TKnobsInput;
    notes: TKnobsModule;
    notes_display: TKnobsDisplay;
    notes_editlabel: TKnobsEditLabel;
    osc_tabsheet: TTabSheet;
    pan: TKnobsModule;
    pan_control: TKnobsInput;
    pan_editlabel: TKnobsEditLabel;
    pan_in: TKnobsInput;
    pan_out1: TKnobsOutput;
    pan_out2: TKnobsOutput;
    pan_position: TKnobsSmallKnob;
    pan_textlabel_control: TKnobsTextLabel;
    pan_textlabel_in: TKnobsTextLabel;
    pan_textlabel_out1: TKnobsTextLabel;
    pan_textlabel_out2: TKnobsTextLabel;
    panel1: TKnobsModule;
    panel2: TKnobsModule;
    panel2_editlabel: TKnobsEditLabel;
    panel3: TKnobsModule;
    panel3_editlabel: TKnobsEditLabel;
    panel4: TKnobsModule;
    panel4_editlabel: TKnobsEditLabel;
    panel5: TKnobsModule;
    panel5_editlabel: TKnobsEditLabel;
    quantize: TKnobsModule;
    quantizer_display_qsteps: TKnobsDisplay;
    quantizer_editlabel: TKnobsEditLabel;
    quantizer_in: TKnobsInput;
    quantizer_mute: TKnobsSelector;
    quantizer_out: TKnobsOutput;
    quantizer_qsteps: TKnobsSmallKnob;
    quantizer_textlabel_in: TKnobsTextLabel;
    quantizer_textlabel_notes: TKnobsTextLabel;
    randomwalklfo: TKnobsModule;
    randomwalklfo_display_distance: TKnobsDisplay;
    randomwalklfo_display_frequency: TKnobsDisplay;
    randomwalklfo_distance: TKnobsSmallKnob;
    randomwalklfo_editlabel: TKnobsEditLabel;
    randomwalklfo_fm: TKnobsInput;
    randomwalklfo_fmlevel: TKnobsSmallKnob;
    randomwalklfo_frequency: TKnobsSmallKnob;
    randomwalklfo_indicator_outx: TKnobsIndicator;
    randomwalklfo_indicator_outy: TKnobsIndicator;
    randomwalklfo_indicator_outz: TKnobsIndicator;
    randomwalklfo_mute: TKnobsSelector;
    randomwalklfo_outx: TKnobsOutput;
    randomwalklfo_outy: TKnobsOutput;
    randomwalklfo_outz: TKnobsOutput;
    randomwalklfo_range: TKnobsSelector;
    randomwalklfo_textlabel_distance: TKnobsTextLabel;
    randomwalklfo_textlabel_fm: TKnobsTextLabel;
    randomwalklfo_textlabel_frequency: TKnobsTextLabel;
    randomwalklfo_textlabel_x: TKnobsTextLabel;
    randomwalklfo_textlabel_y: TKnobsTextLabel;
    randomwalklfo_textlabel_z: TKnobsTextLabel;
    ratio: TKnobsModule;
    ratio_display_divider: TKnobsDisplay;
    ratio_display_multiplier: TKnobsDisplay;
    ratio_divider: TKnobsSmallKnob;
    ratio_editlabel: TKnobsEditLabel;
    ratio_in1: TKnobsInput;
    ratio_in2: TKnobsInput;
    ratio_in3: TKnobsInput;
    ratio_in4: TKnobsInput;
    ratio_multiplier: TKnobsSmallKnob;
    ratio_mute: TKnobsSelector;
    ratio_out1: TKnobsOutput;
    ratio_out2: TKnobsOutput;
    ratio_out3: TKnobsOutput;
    ratio_out4: TKnobsOutput;
    ratio_textlabel_divider: TKnobsTextLabel;
    ratio_textlabel_multiplier: TKnobsTextLabel;
    rectifier: TKnobsModule;
    rectifier_editlabel: TKnobsEditLabel;
    rectifier_image: TImage;
    rectifier_in: TKnobsInput;
    rectifier_mode: TKnobsSelector;
    rectifier_out: TKnobsOutput;
    rectifier_outinv: TKnobsOutput;
    rectifier_textlabel_inv: TKnobsTextLabel;
    rotator: TKnobsModule;
    rotator_angle: TKnobsInput;
    rotator_editlabel: TKnobsEditLabel;
    rotator_in1: TKnobsInput;
    rotator_in2: TKnobsInput;
    rotator_out1: TKnobsOutput;
    rotator_out2: TKnobsOutput;
    rotator_textlabel_angle: TKnobsTextLabel;
    rotator_textlabel_ins: TKnobsTextLabel;
    rotator_textlabel_outs: TKnobsTextLabel;
    rsflipflop: TKnobsModule;
    rsflipflop_editlabel: TKnobsEditLabel;
    rsflipflop_image: TImage;
    rsflipflop_indicator_notq: TKnobsIndicator;
    rsflipflop_indicator_q: TKnobsIndicator;
    rsflipflop_notq: TKnobsOutput;
    rsflipflop_q: TKnobsOutput;
    rsflipflop_r: TKnobsInput;
    rsflipflop_s: TKnobsInput;
    sampleandhold: TKnobsModule;
    sampleandhold_editlabel: TKnobsEditLabel;
    sampleandhold_in: TKnobsInput;
    sampleandhold_indicator_trig: TKnobsIndicator;
    sampleandhold_label_in: TKnobsTextLabel;
    sampleandhold_label_trig: TKnobsTextLabel;
    sampleandhold_out: TKnobsOutput;
    sampleandhold_symbol_trig: TImage;
    sampleandhold_trig: TKnobsInput;
    savedstuff_memo: TMemo;
    savedstuff_pagecontrol: TPageControl;
    savedstuff_tabsheet: TTabSheet;
    scaler: TKnobsModule;
    scaler_display_gain: TKnobsDisplay;
    scaler_display_offset: TKnobsDisplay;
    scaler_editlabel: TKnobsEditLabel;
    scaler_gain: TKnobsSmallKnob;
    scaler_in1: TKnobsInput;
    scaler_in2: TKnobsInput;
    scaler_in3: TKnobsInput;
    scaler_in4: TKnobsInput;
    scaler_mode: TKnobsSelector;
    scaler_mute: TKnobsSelector;
    scaler_offset: TKnobsSmallKnob;
    scaler_out1: TKnobsOutput;
    scaler_out2: TKnobsOutput;
    scaler_out3: TKnobsOutput;
    scaler_out4: TKnobsOutput;
    scaler_textlabel_gain: TKnobsTextLabel;
    scaler_textlabel_lock: TKnobsTextLabel;
    scaler_textlabel_offset: TKnobsTextLabel;
    separator_lfo1: TKnobsModule;
    separator_lfo2: TKnobsModule;
    separator_logic1: TKnobsModule;
    separator_midi: TKnobsModule;
    separator_osc1: TKnobsModule;
    separator_osc2: TKnobsModule;
    separator_util1: TKnobsModule;
    separator_util2: TKnobsModule;
    seqclockstep: TKnobsModule;
    seqclockstep_chain: TKnobsInput;
    seqclockstep_clock: TKnobsInput;
    seqclockstep_counts: TKnobsSmallKnob;
    seqclockstep_dir: TKnobsInput;
    seqclockstep_display_counts: TKnobsDisplay;
    seqclockstep_display_note: TKnobsDisplay;
    seqclockstep_editlabel: TKnobsEditLabel;
    seqclockstep_indicator_active: TKnobsIndicator;
    seqclockstep_indicator_clock: TKnobsIndicator;
    seqclockstep_indicator_count: TKnobsIndicatorText;
    seqclockstep_indicator_dir: TKnobsIndicator;
    seqclockstep_indicator_reset: TKnobsIndicator;
    seqclockstep_indicator_trigbwd: TKnobsIndicator;
    seqclockstep_indicator_trigfwd: TKnobsIndicator;
    seqclockstep_note: TKnobsSmallKnob;
    seqclockstep_out: TKnobsOutput;
    seqclockstep_reset: TKnobsInput;
    seqclockstep_symbol_clockedge: TImage;
    seqclockstep_symbol_sigflow: TImage;
    seqclockstep_symbol_trigbwd: TImage;
    seqclockstep_symbol_trigfwd: TImage;
    seqclockstep_textlabel_clock: TKnobsTextLabel;
    seqclockstep_textlabel_count: TKnobsTextLabel;
    seqclockstep_textlabel_dir: TKnobsTextLabel;
    seqclockstep_textlabel_note: TKnobsTextLabel;
    seqclockstep_textlabel_reset: TKnobsTextLabel;
    seqclockstep_textlabel_trig: TKnobsTextLabel;
    seqclockstep_triginbwd: TKnobsInput;
    seqclockstep_triginfwd: TKnobsInput;
    seqclockstep_trigoutbwd: TKnobsOutput;
    seqclockstep_trigoutfwd: TKnobsOutput;
    seqstep: TKnobsModule;
    seqstep_chain: TKnobsInput;
    seqstep_dir: TKnobsInput;
    seqstep_display_note: TKnobsDisplay;
    seqstep_display_time: TKnobsDisplay;
    seqstep_editlabel: TKnobsEditLabel;
    seqstep_indicator_active: TKnobsIndicator;
    seqstep_indicator_dir: TKnobsIndicator;
    seqstep_indicator_reset: TKnobsIndicator;
    seqstep_indicator_trigbwd: TKnobsIndicator;
    seqstep_indicator_trigfwd: TKnobsIndicator;
    seqstep_note: TKnobsSmallKnob;
    seqstep_out: TKnobsOutput;
    seqstep_reset: TKnobsInput;
    seqstep_symbol_sigflow: TImage;
    seqstep_symbol_trigbwd: TImage;
    seqstep_symbol_trigfwd: TImage;
    seqstep_textlabel_dir: TKnobsTextLabel;
    seqstep_textlabel_duration: TKnobsTextLabel;
    seqstep_textlabel_note: TKnobsTextLabel;
    seqstep_textlabel_res: TKnobsTextLabel;
    seqstep_textlabel_trig: TKnobsTextLabel;
    seqstep_time: TKnobsSmallKnob;
    seqstep_triginbwd: TKnobsInput;
    seqstep_triginfwd: TKnobsInput;
    seqstep_trigoutbwd: TKnobsOutput;
    seqstep_trigoutfwd: TKnobsOutput;
    sequencer: TKnobsModule;
    sequencer_chain: TKnobsInput;
    sequencer_dir: TKnobsInput;
    sequencer_display_step10: TKnobsDisplay;
    sequencer_display_step11: TKnobsDisplay;
    sequencer_display_step1: TKnobsDisplay;
    sequencer_display_step2: TKnobsDisplay;
    sequencer_display_step3: TKnobsDisplay;
    sequencer_display_step4: TKnobsDisplay;
    sequencer_display_step5: TKnobsDisplay;
    sequencer_display_step6: TKnobsDisplay;
    sequencer_display_step7: TKnobsDisplay;
    sequencer_display_step8: TKnobsDisplay;
    sequencer_display_step9: TKnobsDisplay;
    sequencer_display_steps: TKnobsDisplay;
    sequencer_editlabel: TKnobsEditLabel;
    sequencer_indicator_dir: TKnobsIndicator;
    sequencer_indicator_reset: TKnobsIndicator;
    sequencer_indicator_step10: TKnobsIndicator;
    sequencer_indicator_step11: TKnobsIndicator;
    sequencer_indicator_step1: TKnobsIndicator;
    sequencer_indicator_step2: TKnobsIndicator;
    sequencer_indicator_step3: TKnobsIndicator;
    sequencer_indicator_step4: TKnobsIndicator;
    sequencer_indicator_step5: TKnobsIndicator;
    sequencer_indicator_step6: TKnobsIndicator;
    sequencer_indicator_step7: TKnobsIndicator;
    sequencer_indicator_step8: TKnobsIndicator;
    sequencer_indicator_step9: TKnobsIndicator;
    sequencer_indicator_trig: TKnobsIndicator;
    sequencer_out: TKnobsOutput;
    sequencer_reset: TKnobsInput;
    sequencer_step10: TKnobsNoKnob;
    sequencer_step11: TKnobsNoKnob;
    sequencer_step1: TKnobsNoKnob;
    sequencer_step2: TKnobsNoKnob;
    sequencer_step3: TKnobsNoKnob;
    sequencer_step4: TKnobsNoKnob;
    sequencer_step5: TKnobsNoKnob;
    sequencer_step6: TKnobsNoKnob;
    sequencer_step7: TKnobsNoKnob;
    sequencer_step8: TKnobsNoKnob;
    sequencer_step9: TKnobsNoKnob;
    sequencer_steps: TKnobsNoKnob;
    sequencer_symbol_trig: TImage;
    sequencer_tabsheet: TTabSheet;
    sequencer_textlabel_dir: TKnobsTextLabel;
    sequencer_textlabel_reset: TKnobsTextLabel;
    sequencer_textlabel_step10: TKnobsTextLabel;
    sequencer_textlabel_step11: TKnobsTextLabel;
    sequencer_textlabel_step1: TKnobsTextLabel;
    sequencer_textlabel_step2: TKnobsTextLabel;
    sequencer_textlabel_step3: TKnobsTextLabel;
    sequencer_textlabel_step4: TKnobsTextLabel;
    sequencer_textlabel_step5: TKnobsTextLabel;
    sequencer_textlabel_step6: TKnobsTextLabel;
    sequencer_textlabel_step7: TKnobsTextLabel;
    sequencer_textlabel_step8: TKnobsTextLabel;
    sequencer_textlabel_step9: TKnobsTextLabel;
    sequencer_textlabel_steps: TKnobsTextLabel;
    sequencer_textlabel_trig: TKnobsTextLabel;
    sequencer_trig10: TKnobsOutput;
    sequencer_trig11: TKnobsOutput;
    sequencer_trig1: TKnobsOutput;
    sequencer_trig2: TKnobsOutput;
    sequencer_trig3: TKnobsOutput;
    sequencer_trig4: TKnobsOutput;
    sequencer_trig5: TKnobsOutput;
    sequencer_trig6: TKnobsOutput;
    sequencer_trig7: TKnobsOutput;
    sequencer_trig8: TKnobsOutput;
    sequencer_trig9: TKnobsOutput;
    sequencer_trig: TKnobsInput;
    control_tabsheet: TTabSheet;
    osc: TKnobsModule;
    osc_display_frequency: TKnobsDisplay;
    osc_editlabel: TKnobsEditLabel;
    osc_fm: TKnobsInput;
    osc_frequency: TKnobsSmallKnob;
    osc_mute: TKnobsSelector;
    osc_out: TKnobsOutput;
    osc_phase: TKnobsInput;
    osc_sync: TKnobsInput;
    osc_symbol_sync: TImage;
    osc_textlabel_fm: TKnobsTextLabel;
    osc_textlabel_phase: TKnobsTextLabel;
    osctrig: TKnobsModule;
    osctrig_count: TKnobsNoKnob;
    osctrig_display_count: TKnobsDisplay;
    osctrig_display_frequency: TKnobsDisplay;
    osctrig_editlabel: TKnobsEditLabel;
    osctrig_fm: TKnobsInput;
    osctrig_frequency: TKnobsSmallKnob;
    osctrig_indicator_trig: TKnobsIndicator;
    osctrig_mute: TKnobsSelector;
    osctrig_out: TKnobsOutput;
    osctrig_symbol_trig: TImage;
    osctrig_textlabel_fm: TKnobsTextLabel;
    osctrig_textlabel_trig: TKnobsTextLabel;
    osctrig_trig: TKnobsInput;
    square: TKnobsModule;
    square_display_frequency: TKnobsDisplay;
    square_editlabel: TKnobsEditLabel;
    square_fm: TKnobsInput;
    square_frequency: TKnobsSmallKnob;
    square_mute: TKnobsSelector;
    square_out: TKnobsOutput;
    square_phase: TKnobsInput;
    square_pwm: TKnobsInput;
    square_sync: TKnobsInput;
    square_symbol_sync: TImage;
    square_textlabel_fm: TKnobsTextLabel;
    square_textlabel_phase: TKnobsTextLabel;
    square_textlabel_pwm: TKnobsTextLabel;
    square_textlabel_sync: TKnobsTextLabel;
    squarelfo: TKnobsModule;
    squarelfo_display_frequency: TKnobsDisplay;
    squarelfo_editlabel: TKnobsEditLabel;
    squarelfo_fm: TKnobsInput;
    squarelfo_frequency: TKnobsSmallKnob;
    squarelfo_image: TImage;
    squarelfo_indicator_out: TKnobsIndicator;
    squarelfo_indicator_res: TKnobsIndicator;
    squarelfo_mute: TKnobsSelector;
    squarelfo_out: TKnobsOutput;
    squarelfo_phase: TKnobsInput;
    squarelfo_pwm: TKnobsInput;
    squarelfo_res: TKnobsInput;
    squarelfo_symbol_res: TImage;
    squarelfo_sync: TKnobsOutput;
    squarelfo_textlabel_fm: TKnobsTextLabel;
    squarelfo_textlabel_phase: TKnobsTextLabel;
    squarelfo_textlabel_pwm: TKnobsTextLabel;
    squarelfo_textlabel_res: TKnobsTextLabel;
    squarelfo_textlabel_sync: TKnobsTextLabel;
    squarelfotrig: TKnobsModule;
    squarelfotrig_count: TKnobsNoKnob;
    squarelfotrig_display_count: TKnobsDisplay;
    squarelfotrig_display_frequency: TKnobsDisplay;
    squarelfotrig_editlabel: TKnobsEditLabel;
    squarelfotrig_fm: TKnobsInput;
    squarelfotrig_frequency: TKnobsSmallKnob;
    squarelfotrig_image: TImage;
    squarelfotrig_indicator_out: TKnobsIndicator;
    squarelfotrig_indicator_ready: TKnobsIndicator;
    squarelfotrig_indicator_trig: TKnobsIndicator;
    squarelfotrig_mute: TKnobsSelector;
    squarelfotrig_out: TKnobsOutput;
    squarelfotrig_pwm: TKnobsInput;
    squarelfotrig_ready: TKnobsOutput;
    squarelfotrig_symbol_trig: TImage;
    squarelfotrig_textlabel_fm: TKnobsTextLabel;
    squarelfotrig_textlabel_ready: TKnobsTextLabel;
    squarelfotrig_textlabel_trig: TKnobsTextLabel;
    squarelfotrig_trig: TKnobsInput;
    squarelftrig_textlabel_trig: TKnobsTextLabel;
    squaretrig: TKnobsModule;
    squaretrig_count: TKnobsNoKnob;
    squaretrig_display_count: TKnobsDisplay;
    squaretrig_display_frequency: TKnobsDisplay;
    squaretrig_editlabel: TKnobsEditLabel;
    squaretrig_fm: TKnobsInput;
    squaretrig_frequency: TKnobsSmallKnob;
    squaretrig_indicator_trig: TKnobsIndicator;
    squaretrig_mute: TKnobsSelector;
    squaretrig_out: TKnobsOutput;
    squaretrig_pwm: TKnobsInput;
    squaretrig_symbol_trig: TImage;
    squaretrig_textlabel_fm: TKnobsTextLabel;
    squaretrig_textlabel_pwm: TKnobsTextLabel;
    squaretrig_textlabel_trig: TKnobsTextLabel;
    squaretrig_trig: TKnobsInput;
    svf: TKnobsModule;
    svf_bp: TKnobsOutput;
    svf_br: TKnobsOutput;
    svf_display_frequency: TKnobsDisplay;
    svf_distortion: TKnobsSmallKnob;
    svf_editlabel: TKnobsEditLabel;
    svf_fm: TKnobsInput;
    svf_frequency: TKnobsSmallKnob;
    svf_hp: TKnobsOutput;
    svf_in: TKnobsInput;
    svf_lp: TKnobsOutput;
    svf_q: TKnobsSmallKnob;
    svf_textlabel_bp: TKnobsTextLabel;
    svf_textlabel_br: TKnobsTextLabel;
    svf_textlabel_distortion: TKnobsTextLabel;
    svf_textlabel_frequency_in: TKnobsTextLabel;
    svf_textlabel_hp: TKnobsTextLabel;
    svf_textlabel_in: TKnobsTextLabel;
    svf_textlabel_lp: TKnobsTextLabel;
    svf_textlabel_q: TKnobsTextLabel;
    switch2to1: TKnobsModule;
    switch2to1_control: TKnobsInput;
    switch2to1_editlabel: TKnobsEditLabel;
    switch2to1_in1: TKnobsInput;
    switch2to1_in2: TKnobsInput;
    switch2to1_indicator_control: TKnobsIndicator;
    switch2to1_out: TKnobsOutput;
    switch2to1_textlabel_control: TKnobsTextLabel;
    switch2to1_textlabel_in1: TKnobsTextLabel;
    switch2to1_textlabel_in2: TKnobsTextLabel;
    switch_tabsheet: TTabSheet;
    textsequencer: TKnobsModule;
    textsequencer_dir: TKnobsInput;
    textsequencer_editlabel: TKnobsEditLabel;
    textsequencer_indicator_dir: TKnobsIndicator;
    textsequencer_indicator_reset: TKnobsIndicator;
    textsequencer_indicator_step: TKnobsIndicatorText;
    textsequencer_indicator_steps: TKnobsIndicatorText;
    textsequencer_indicator_trig: TKnobsIndicator;
    textsequencer_label_slash: TLabel;
    textsequencer_mode: TKnobsSelector;
    textsequencer_out: TKnobsOutput;
    textsequencer_reset: TKnobsInput;
    textsequencer_symbol_trig: TImage;
    textsequencer_textlabel_dir: TKnobsTextLabel;
    textsequencer_textlabel_reset: TKnobsTextLabel;
    textsequencer_textlabel_trig: TKnobsTextLabel;
    textsequencer_trig: TKnobsInput;
    textsequencer_values: TKnobsDisplay;
    trackandhold: TKnobsModule;
    trackandhold_editlabel: TKnobsEditLabel;
    trackandhold_in: TKnobsInput;
    trackandhold_indicator_trig: TKnobsIndicator;
    trackandhold_label_in: TKnobsTextLabel;
    trackandhold_label_trig: TKnobsTextLabel;
    trackandhold_out: TKnobsOutput;
    trackandhold_symbol_trig: TImage;
    trackandhold_trig: TKnobsInput;
    util_tabsheet: TTabSheet;
    waveplayer: TKnobsModule;
    waveplayer_display_duration: TKnobsDisplay;
    waveplayer_display_mono: TKnobsDisplay;
    waveplayer_editlabel: TKnobsEditLabel;
    waveplayer_fileselector_filename: TKnobsFileSelector;
    waveplayer_indicator_res: TKnobsIndicator;
    waveplayer_mode: TKnobsSelector;
    waveplayer_out: TKnobsOutput;
    waveplayer_outr: TKnobsOutput;
    waveplayer_position: TKnobsInput;
    waveplayer_res: TKnobsInput;
    waveplayer_speed: TKnobsInput;
    waveplayer_symbol_res: TImage;
    waveplayer_textlabel_duration: TKnobsTextLabel;
    waveplayer_textlabel_l: TKnobsTextLabel;
    waveplayer_textlabel_position: TKnobsTextLabel;
    waveplayer_textlabel_r: TKnobsTextLabel;
    waveplayer_textlabel_res: TKnobsTextLabel;
    waveplayer_textlabel_speed: TKnobsTextLabel;
    xfade: TKnobsModule;
    xfade_control: TKnobsInput;
    xfade_editlabel: TKnobsEditLabel;
    xfade_in1: TKnobsInput;
    xfade_in2: TKnobsInput;
    xfade_out: TKnobsOutput;
    xfade_position: TKnobsSmallKnob;
    xfade_textlabel_control: TKnobsTextLabel;
    xfade_textlabel_in1: TKnobsTextLabel;
    xfade_textlabel_in2: TKnobsTextLabel;
    xfade_textlabel_out: TKnobsTextLabel;
    hrastSVF: TKnobsModule;
    hrastSVF_editlable: TKnobsEditLabel;
    hrastSVF_output12: TKnobsOutput;
    hrastSVF_input: TKnobsInput;
    hrastSVF_cutoffinput: TKnobsInput;
    hrastSVF_textlabel_in: TKnobsTextLabel;
    hrastSVF_textlabel_fm: TKnobsTextLabel;
    hrastSVF_textlabel_qm: TKnobsTextLabel;
    hrastSVF_resoinput: TKnobsInput;
    hrastSVF_textlabel_q: TKnobsTextLabel;
    hrastSVF_textlabel_drive: TKnobsTextLabel;
    hrastSVF_textlabel_lp: TKnobsTextLabel;
    hrastSVF_textlabel_bp: TKnobsTextLabel;
    hrastSV_textlabel_hp: TKnobsTextLabel;
    hrastSVF_textlabel_freq: TKnobsTextLabel;
    hrastSVF_textlabel_outlp: TKnobsTextLabel;
    hrastSVF_outputlp: TKnobsOutput;
    hrastSV_textlabel_outbp: TKnobsTextLabel;
    hrastSVF_outputbp: TKnobsOutput;
    hrastSV_textlabel_outhp: TKnobsTextLabel;
    hrastSVF_outputhp: TKnobsOutput;
    hrastSVF_textlabel_outbr: TKnobsTextLabel;
    hrastSVF_outputbr: TKnobsOutput;
    hrastSVF_output24: TKnobsOutput;
    hrastSVF_textlabel_12db: TKnobsTextLabel;
    hrastSVF_textlabel_24db: TKnobsTextLabel;
    hrastSVF_textlabel_out12db: TKnobsTextLabel;
    hrastSVF_textlabel_out24db: TKnobsTextLabel;
    hrastSVF_image: TImage;
    hrastSVF_cutoff: TKnobsSmallKnob;
    hrastSVF_display_cutoff: TKnobsDisplay;
    hrastSVF_lowpass: TKnobsSmallKnob;
    hrastSVF_reso: TKnobsSmallKnob;
    hrastSVF_bandpass: TKnobsSmallKnob;
    hrastSVF_highpass: TKnobsSmallKnob;
    hrastSVF_drive: TKnobsSmallKnob;
    hrastSVF_resomod: TKnobsSmallKnob;
    hrastSVF_cutoffmod: TKnobsSmallKnob;
    hrastSVF_gain: TKnobsSmallKnob;
    hrastSVF_level12: TKnobsSmallKnob;
    hrastSVF_level24: TKnobsSmallKnob;
    ImageHrastSVF: TImage;
    MemoHrastSVF: TMemo;
    separator_filter1: TKnobsModule;
    osc_shape: TKnobsSelector;
    osc_textlabel_sync: TKnobsTextLabel;
    osc_fmlevel: TKnobsSmallKnob;
    osc_pmlevel: TKnobsSmallKnob;
    osc_cents: TKnobsSmallKnob;
    osc_display_fine: TKnobsDisplay;
    osctrig_shape: TKnobsSelector;
    osctrig_fmlevel: TKnobsSmallKnob;
    osctrig_cents: TKnobsSmallKnob;
    osctrig_display_fine: TKnobsDisplay;
    textsequencer_chain: TKnobsInput;
    svf_fmlevel: TKnobsSmallKnob;
    svf_inlevel: TKnobsSmallKnob;
    mixm4to1_mode: TKnobsSelector;
    mixs2to1_mode: TKnobsSelector;
    mixm6to6_mode: TKnobsSelector;
    waveplayer_fm: TKnobsInput;
    waveplayer_textlabel_fm: TKnobsTextLabel;
    square_cents: TKnobsSmallKnob;
    square_display_fine: TKnobsDisplay;
    square_pmlevel: TKnobsSmallKnob;
    square_fmlevel: TKnobsSmallKnob;
    square_pwmlevel: TKnobsSmallKnob;
    squaretrig_cents: TKnobsSmallKnob;
    squaretrig_display_fine: TKnobsDisplay;
    squaretrig_pwmlevel: TKnobsSmallKnob;
    squaretrig_fmlevel: TKnobsSmallKnob;
    squarelfo_fmlevel: TKnobsSmallKnob;
    squarelfo_pmlevel: TKnobsSmallKnob;
    squarelfo_range: TKnobsSelector;
    squarelfo_pwmlevel: TKnobsSmallKnob;
    squarelfotrig_fmlevel: TKnobsSmallKnob;
    squarelfotrig_pwmlevel: TKnobsSmallKnob;
    randomwalklfo_color: TKnobsSmallKnob;
    randomwalklfo_textlabel_color: TKnobsTextLabel;
    hrastosc_cents: TKnobsSmallKnob;
    hrastosc_display_fine: TKnobsDisplay;
    randomwalklfo_display_color: TKnobsDisplay;
    envahd_amodlevel: TKnobsSmallKnob;
    envahd_amod: TKnobsInput;
    envahd_hmodlevel: TKnobsSmallKnob;
    envahd_hmod: TKnobsInput;
    envahd_dmodlevel: TKnobsSmallKnob;
    envahd_dmod: TKnobsInput;
    envahd_hrange: TKnobsSelector;
    envahd_drange: TKnobsSelector;
    envadsr_amodlevel: TKnobsSmallKnob;
    envadsr_amod: TKnobsInput;
    envadsr_dmodlevel: TKnobsSmallKnob;
    envadsr_dmod: TKnobsInput;
    envadsr_smodlevel: TKnobsSmallKnob;
    envadsr_smod: TKnobsInput;
    envadsr_rmodlevel: TKnobsSmallKnob;
    envadsr_rmod: TKnobsInput;
    envadsr_rrange: TKnobsSelector;
    envadsr_drange: TKnobsSelector;
    constant_mode: TKnobsSelector;
    amplifier_mode: TKnobsSelector;
    envahd_amodneg: TKnobsInput;
    envahd_hmodneg: TKnobsInput;
    envahd_dmodneg: TKnobsInput;
    envadsr_amodneg: TKnobsInput;
    envadsr_dmodneg: TKnobsInput;
    envadsr_smodneg: TKnobsInput;
    envadsr_rmodneg: TKnobsInput;
    envahd_textlabel_plus: TKnobsTextLabel;
    envahd_textlabel_minus: TKnobsTextLabel;
    envadsr_textkabel_plus: TKnobsTextLabel;
    envadsr_textkabel_minus: TKnobsTextLabel;
    squarelfo_textlabel_out: TKnobsTextLabel;
    squarelfo_textlabel_trig: TKnobsTextLabel;
    noiselfo_textlabel_out: TKnobsTextLabel;
    noiselfotrig_textlabel_out: TKnobsTextLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FModules       : TKnobsModuleList;
    FOnDesignerLog : TOnDesignerLog;
  private
    procedure   DoModuleListLog( aSender: TObject; const aMsg: string);
    procedure   DoModuleLog    ( aSender: TObject; const aMsg: string);
    procedure   RegisterModules;
    procedure   Log( const aMsg: string);
    procedure   LogFmt( const aFmt: string; const anArgs: array of const);
  public
    function    CreateModule(
      aWirePanel  : TKnobsWirePanel;
      aModuleType : TKnobsModuleType;
      MustDrag    : Boolean
    ): TKnobsCustomModule;

    procedure   PopulateSelector  ( aModuleSelector: TKnobsModuleSelector);
    procedure   ShowModule        ( const aModule: TKnobsCustomModule);
    function    CreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    function    ReadModuleComment ( const aModuleType: TKnobsModuleType): string;
    procedure   MakeImage         ( const aFolder: string; const aModule: TKnobsCustomModule);
    procedure   MakeImages        ( const aFolder: string);
    function    FindBitmap        ( const aModuleTitle: string): TBitmap;
    function    FindDocu          ( const aModuleTitle: string): TStrings;
    function    DocumentModule    ( const aModule: TKnobsCustomModule; const anImagesFolder: string; anIndex: Integer): string;
    function    MakeDocIndex      : string;
    function    MakeDocHeader     ( const aVersion: string): string;
    function    MakeDocFooter     : string;
    function    DoDocument        ( const aFolder, anImagesFolder, aVersion: string): string;
    procedure   Document          ( const aFolder, anImagesFolder, aVersion: string);
  public
    property    Modules       : TKnobsModuleList read FModules;
    property    OnDesignerLog : TOnDesignerLog   read FOnDesignerLog write FOnDesignerLog;
  end;


var

  FormStore: TFormStore;


implementation


{$R *.DFM}


// User area


//  private


    // -------------------------------------------------------------------------

    procedure   TFormStore.DoModuleListLog( aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'ModuleList (%s)', [ aMsg]);
    end;

    procedure   TFormStore.DoModuleLog( aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'Module (%s)', [ aMsg]);
    end;

    procedure   TFormStore.RegisterModules;
    var
      i : Integer;
    begin
      FModules := TKnobsModuleList.Create;

      FModules.OnLog := DoModuleListLog;

      for i := 0 to ComponentCount - 1
      do begin
        if ( Components[ i] is TKnobsCustomModule)
        then begin
          TKnobsCustomModule( Components[ i]).FixDisplays;
          TKnobsCustomModule( Components[ i]).OnLog := DoModuleLog;
          FModules.Add( Components[ i]);
        end;
      end;

      FModules.RegisterComponents( True);
    end;

    procedure   TFormStore.Log( const aMsg: string);
    begin
      if Assigned( FOnDesignerLog)
      then FOnDesignerLog( Self, Format( 'designer (%s)', [ aMsg]));
    end;

    procedure   TFormStore.LogFmt( const aFmt: string; const anArgs: array of const);
    begin
      Log( Format( aFmt, anArgs));
    end;


//  public


    function    TFormStore.CreateModule(
      aWirePanel  : TKnobsWirePanel;
      aModuleType : TKnobsModuleType;
      MustDrag    : Boolean
    ): TKnobsCustomModule;
    begin
      Result := FModules.CreateModule( aWirePanel, aModuleType, MustDrag);
      if Assigned( Result) and Assigned( aWirePanel)
      then Result.ControlMode := aWirePanel.ControlMode;
    end;


    procedure   TFormStore.PopulateSelector( aModuleSelector: TKnobsModuleSelector);
    begin
      FModules.PopulateSelector( aModuleSelector);
    end;

    procedure   TFormStore.ShowModule( const aModule: TKnobsCustomModule);
    var
      aTabSheet: TTabSheet;
    begin
      aTabSheet := aModule.Parent as TTabSheet;
      savedstuff_pagecontrol.ActivePage := aTabSheet;
    end;

    function    TFormStore.CreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    var
      i : Integer;
    begin
      Result := nil;
      if Assigned( FModules)
      then begin
        for i := 0 to FModules.Count - 1
        do begin
          if FModules[ i].ModuleType = aModuleType
          then begin
            Result := FModules[ i].AsBitmap;
            Break;
          end;
        end;
      end;
    end;

    function    TFormStore.ReadModuleComment( const aModuleType: TKnobsModuleType): string;
    var
      i : Integer;
    begin
      Result := '';
      if Assigned( FModules)
      then begin
        for i := 0 to FModules.Count - 1
        do begin
          if FModules[ i].ModuleType = aModuleType
          then begin
            Result := FModules[ i].Comment;
            if Result = ''
            then Result := FModules[ i].Title;
            Break;
          end;
        end;
      end;
    end;

    procedure   TFormStore.MakeImage( const aFolder: string; const aModule: TKnobsCustomModule);
    var
      aBitmap   : TBitmap;
      aFileName : string;
      aJPeg     : TJPEGImage;
    begin
      if Assigned( aModule)
      then begin
        aFileName := aFolder + '\TMod' + aModule.Title + '.jpg';
        aBitmap := aModule.AsBitmap;
        try
          aJpeg := TJPEGImage.Create;
          try
            aJpeg.CompressionQuality  := 90;
            aJpeg.ProgressiveEncoding := True;
            aJpeg.Assign( aBitmap);
            aJpeg.Compress;
            aJpeg.SaveToFile( aFileName);
          finally
            FreeAndNil( aJpeg);
          end;
        finally
          aBitmap.Free;
        end;
      end;
    end;

    procedure   TFormStore.MakeImages( const aFolder: string);
    var
      i : Integer;
    begin
      for i := 0 to FModules.Count - 1
      do begin
        ShowModule( FModules[ i]);
        MakeImage( aFolder, FModules[ i]);
      end;
    end;

    function    TFormStore.FindBitmap( const aModuleTitle: string): TBitmap;
    var
      i      : Integer;
      anImage: TImage;
    begin
      Result := nil;
      for i := 0 to ComponentCount - 1
      do begin
        if Components[ i] is TImage
        then begin
          anImage := TImage( Components[ i]);
          if SameText( anImage.Name, Format( 'Image%s', [ aModuleTitle]))
          then Result := anImage.Picture.Bitmap;
        end;
      end;
    end;


    function    TFormStore.FindDocu( const aModuleTitle: string): TStrings;
    var
      i     : Integer;
      aMemo : TMemo;
    begin
      Result := nil;
      for i := 0 to ComponentCount - 1
      do begin
        if Components[ i] is TMemo
        then begin
          aMemo := TMemo( Components[ i]);
          if SameText( aMemo.Name, Format( 'Memo%s', [ aModuleTitle]))
          then Result := aMemo.Lines;
        end;
      end;
    end;

    function    TFormStore.DocumentModule( const aModule: TKnobsCustomModule; const anImagesFolder: string; anIndex: Integer): string;
    var
      aDocu : TStrings;
      i     : Integer;
      First : Boolean;
      aType : Integer;
    begin
      Result := '';
      if Assigned( aModule)
      then begin
        aDocu := FindDocu( aModule.Title);
        if Assigned( aDocu)
        then begin
          First := True;
          for i := 0 to aDocu.Count - 1
          do begin
            if aDocu[ i] <> ''
            then begin
              if First
              then begin
                First  := False;
                aType  := aModule.ModuleType;
                Result := Result + '<a href=''#index''>index</a>';
                Result := Result + Format( '<h2><a id=''%d'' name=''%d''>%d %s</a></h2>'^M, [ aType, aType, anIndex, aDocu[ i]]);
                Result := Result + Format( '<h3>Page: %s</h3>'^M                          , [ aModule.PageName                ]);
                Result := Result + Format( '<img src=''./images/TMod%s.jpg''>'^M          , [ aModule.Title                   ]);
                Result := Result + Format( '<p>Type: %d'^M                                , [ aType                           ]);
              end
              else Result := Result + Format( '%s'^M  , [ aDocu[ i]]);
            end
            else begin
              if not First
              then Result := Result + ^M + '<p>';
            end;
          end;
          Result := Result + ^M + '<hr>'^M;
        end;
      end;
    end;

    function    TFormStore.MakeDocIndex: string;
    const
      Header    = '<tr><th>#</th><th>Page</th><th>Module type</th><th>Looks</th></tr>'^M;
      Separator = '<tr><th colspan=''4''><hr></th></tr>'^M;
    var
      i         : Integer;
      aPage     : string;
      anOldPage : string;
      aModule   : string;
      aType     : Integer;
    begin
      anOldPage := '';
      Result    := '';
      Result    := Result + '<table>'^M'<tbody>'^M;
      Result    := Result + Header;
      for i := 0 to FModules.Count - 1
      do begin
        with Modules[ i]
        do begin
          aType   := ModuleType;
          if aType >= 0
          then begin
            aPage     := PageName;
            aModule   := Title;
            if not SameText( anOldPage, aPage)
            then Result := Result + Separator;
            Result    := Result + Format( '<tr><td>%d</td><td>%s</td><td><a href=''#%d''>%s</a></td><td><a href=''#%d''><img src=''./images/TMod%s.jpg''></a></td></tr>', [ i + 1, aPage, aType, aModule, aType, aModule]);
            anOldPage := aPage;
          end;
        end;
      end;
      Result := Result + '</tbody>'^M'</table>'^M;
    end;

    function    TFormStore.MakeDocHeader( const aVersion: string): string;
    begin
      Result := '';
      Result := Result + '<!doctype html>'^M'<html>'^M'<head>'^M'<title>WREN module documentation</title>'^M'</head>'^M;
      Result := Result + '<h1><a name=''index'' id=''index''>WREN module documentation</a></h1>'^M;
      Result := Result + Format( '<h3>Version : %s</h3>'^M, [ aVersion]);
      Result := Result + '<p> COPYRIGHT 1999 - 2014 Blue Hell</p>';
      Result := Result + '<p> COPYRIGHT 2014 HrastProgrammer</p>';
      Result := Result + '<p>Look <a href=''http://bluehell.electro-music.com/modules/''>here</a> for more information.</p>'^M;
      Result := Result + MakeDocIndex;
      Result := Result + '<hr>';
    end;

    function    TFormStore.MakeDocFooter: string;
    begin
      Result := '';
      Result := Result + '<p> COPYRIGHT 1999 - 2014 Blue Hell</p>';
      Result := Result + '<p> COPYRIGHT 2014 HrastProgrammer</p>';
      Result := Result + '<p>Look <a href=''http://bluehell.electro-music.com/modules/''>here</a> for more information.</p>'^M;
      Result := Result + '<p>~~ fin ~~</p>';
      Result := Result + '</body>'^M'</html>';
    end;

    function    TFormStore.DoDocument( const aFolder, anImagesFolder, aVersion: string): string; // overload;
    var
      i : Integer;
    begin
      Result := MakeDocHeader( aVersion);
      for i := 0 to FModules.Count - 1
      do begin
        ShowModule( FModules[ i]);
        MakeImage( aFolder + anImagesFolder, FModules[ i]);
        Result := Result + DocumentModule( FModules[ i], anImagesFolder, i + 1);
      end;
      Result := Result + MakeDocFooter;
    end;

    procedure   TFormStore.Document( const aFolder, anImagesFolder, aVersion: string); // overload;
    var
      aFileName : string;
      aFile     : TextFile;
      Data      : string;
    begin
      Data := '';
      aFileName := aFolder + '\modules.html';
      AssignFile( aFile, aFileName);
      try
        Rewrite( aFile);
        Write( aFile, DoDocument( aFolder, anImagesFolder, aVersion));
      finally
        CloseFile( aFile);
      end;
    end;


// Delphi area



procedure TFormStore.FormCreate(Sender: TObject);
begin
  FModules := nil;
  RegisterModules;
end;


procedure TFormStore.FormDestroy(Sender: TObject);
begin
  if Assigned( FModules)
  then begin
    FModules.RegisterComponents( False);
    FModules.Free;
  end;
end;

end.
